#define COLS 4
#define ROWS 3

#define DBUF_SIZE 0x1f
#define CBUF_SIZE 4

#define lp  5
#define lh  50
#define lr  3

enum keyst {rls,prs,hold} btn[COLS*ROWS]={rls};

struct GDF
{
 GPIO_TypeDef *GPIOx;
 GPIO_Pin_TypeDef GPIO_Pin;
};

GDF GPIO_cols[COLS]=
{
 {
  GPIOB,
  GPIO_PIN_1
 },
 {
  GPIOD,
  GPIO_PIN_0
 },
 {
  GPIOD,
  GPIO_PIN_7
 },
 {
  GPIOF,
  GPIO_PIN_4
 }
};

GDF GPIO_rows[ROWS]=
{
 {
  GPIOB,
  GPIO_PIN_2
 },
 {
  GPIOD,
  GPIO_PIN_3
 },
 {
  GPIOB,
  GPIO_PIN_6
 }
};

GDF GPIO_btn =
{
 GPIOE,
 GPIO_PIN_5
};

enum oprt
{
 OP_NULL=0,
 OP_0,
 OP_1,
 OP_2,
 OP_3,
 OP_4,
 OP_5,
 OP_6,
 OP_7,
 OP_8,
 OP_9,
 OP_ENT,
 OP_BSP
};

oprt data_buffer[DBUF_SIZE];
oprt command_buffer[CBUF_SIZE];

void cops_2_cbuf (const oprt ops, oprt command_buffer[], u8);
void clear_data_buffer (void)                                                  ;
void clear_command_buffer (void)                                               ;
void cops_dops (const oprt ops, oprt command_buffer[], oprt data_buffer[])     ;
void dops_2_dbuf(const oprt ops, oprt data_buffer[], u8)    ;
void key_2_ops(u8 n_b, oprt *ops)                                              ;
u8 scan_keys(GDF *GPIO_cols, GDF *GPIO_rows, keyst btn[])                      ;
void init_kb_pins(GDF *GPIO_cols, GDF *GPIO_rows)                              ;
void init_btn_pin(GDF*);
void read_key(bool *, u8 [][3], keyst *, const u8);
bool read_btn(void);